#include <stdint.h>

typedef struct {
	uint8_t		value;
} value_t;

struct core {
	value_t		memory[65536];
	uint8_t		read[65536];		// These (read/written) are booleans, but
	uint8_t		written[65536];		// kept separate for performance reasons.
};

enum {
	ERR_OK,
	ERR_BRK,
	ERR_INTERNAL,
	ERR_ILLEGAL,
	ERR_CYCLES,
};

enum {
	RET_SUCCESS,
	RET_HEADER,
	RET_RSID,
	RET_MUS,
	RET_BASIC,
	RET_PSID,
};

extern char *emulate_err[];

int emulate(struct core *core, uint16_t start_addr, uint8_t acc, int max_cycles);
